﻿Public Module LaunchApp
    Public WithEvents tray As New NotifyIcon
    Public WithEvents MainMenu As New ContextMenuStrip
    Public WithEvents mnuDisplayForm As New ToolStripMenuItem
    Public WithEvents mnuR1, mnuR2, mnuR3, mnuR4 As New ToolStripMenuItem
    Public WithEvents mnuSep1 As New ToolStripSeparator
    Public WithEvents mnuExit As New ToolStripMenuItem
    Public WithEvents mnuCOMS As New ToolStripComboBox


    Public Sub Main()

        Try
            If PrevInstance() Then
                'mehrfachen Programmstart verhindern
                End
            End If
        Catch ex As Exception

        End Try


        'Turn visual styles back on
        Application.EnableVisualStyles()

        mnuDisplayForm.Text = "Show Menue"
        mnuCOMS.Text = "Select Relaycard"
        mnuR1.Text = "Relay 1"
        mnuR2.Text = "Relay 2"
        mnuR3.Text = "Relay 3"
        mnuR4.Text = "Relay 4"

        tray.Icon = My.Resources.Conrad_transp
        tray.Text = "Relaycard Tray Application"
        mnuExit.Text = "Quit"

        'Display
        tray.Visible = True
        MainMenu.Items.AddRange(New ToolStripItem() {mnuDisplayForm, mnuSep1, mnuCOMS, mnuSep1, mnuR1, mnuR2, mnuR3, mnuR4, mnuSep1, mnuExit})
        tray.ContextMenuStrip = MainMenu
        Try
            Dim ReturnStrings() As String = List_All_Connected_Cp2104()
            If ReturnStrings(0) <> "ERROR" Then
                mnuCOMS.Items.AddRange(ReturnStrings)
                If (GetSetting("USB Relaycard Tray", "Configuration", "COM")) = Nothing And mnuCOMS.Items.Count <> 0 Then
                    mnuCOMS.SelectedIndex = 0
                End If
            Else
                MsgBox("No relay Cards Detected!" + vbNewLine + "- Driver installed?" + vbNewLine + "- Card Connected?" + vbNewLine + "- VREL Jumper Setting OK?", MsgBoxStyle.Critical, "ERROR!")
                tray.Visible = False
                End
            End If

        Catch ex As Exception
            MsgBox("No relay Cards Detected!" + vbNewLine + "- Driver installed?" + vbNewLine + "- Card Connected?" + vbNewLine + "- VREL Jumper Setting OK?", MsgBoxStyle.Critical, "ERROR!")
        End Try

        Application.Run(New AppContext)

    End Sub

    'Ermittelt, ob bereits eine Programminstanz läuft
    Private Function PrevInstance() As Boolean
        If UBound(Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)) > 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub mnuExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles mnuExit.Click
        tray.Visible = False
        End
    End Sub

    Private Sub Tray_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tray.DoubleClick, mnuDisplayForm.Click
        If PopupForm.Visible = False Then
            Dim result As DialogResult
            result = PopupForm.ShowDialog()
            If result = DialogResult.Abort Then
                tray.Dispose()
                End
            End If
        End If
    End Sub

    Private Sub tray_MouseClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles tray.MouseClick
        If e.Button = MouseButtons.Right Then
            PopupForm.Close()
            MainMenu.Show()

        Else
            If PopupForm.Visible = False Then
                Dim result As DialogResult
                result = PopupForm.ShowDialog()
                If result = DialogResult.Abort Then
                    tray.Dispose()
                    End
                End If
            End If
        End If
    End Sub

    Private Sub mnuRels_Click(sender As Object, e As System.EventArgs) Handles mnuR1.Click, mnuR2.Click, mnuR3.Click, mnuR4.Click
        If sender.checked = True Then
            sender.checked = False
        Else
            sender.checked = True
        End If

        SET_OUTPUTS(mnuR1.Checked, mnuR2.Checked, mnuR3.Checked, mnuR4.Checked)
        status_2_checked()
    End Sub

    Private Sub status_2_checked()
        Dim state As Byte
        state = Read_Status()

        If state <> &HFF Then
            If (state And CP210x_GPIO_0) = CP210x_GPIO_0 Then
                mnuR1.Checked = True
            Else
                mnuR1.Checked = False
            End If

            If (state And CP210x_GPIO_1) = CP210x_GPIO_1 Then
                mnuR2.Checked = True
            Else
                mnuR2.Checked = False
            End If

            If (state And CP210x_GPIO_2) = CP210x_GPIO_2 Then
                mnuR3.Checked = True
            Else
                mnuR3.Checked = False
            End If

            If (state And CP210x_GPIO_3) = CP210x_GPIO_3 Then
                mnuR4.Checked = True
            Else
                mnuR4.Checked = False
            End If
        End If
    End Sub

    Private Sub MainMenu_Opening(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles MainMenu.Opening
        status_2_checked()
    End Sub

    Public Class AppContext
        Inherits ApplicationContext

        Public Sub New()
            'Initialize the menus

            'Display
            tray.Visible = True
        End Sub

        Private Sub AppContext_ThreadExit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ThreadExit
            'Guarantees that the icon will not linger.
            tray.Visible = False
        End Sub
    End Class

    Private Sub mnuCOMS_DropDown(sender As Object, e As System.EventArgs) Handles mnuCOMS.DropDown
        Dim ReturnStrings() As String = List_All_Connected_Cp2104()

        mnuCOMS.Items.Clear()
        If ReturnStrings(0) <> "ERROR" Then
            mnuCOMS.Items.AddRange(ReturnStrings)
        Else
            MsgBox("No relay Cards Detected!" + vbNewLine + "- Driver installed?" + vbNewLine + "- Card Connected?" + vbNewLine + "- VREL Jumper Setting OK?", MsgBoxStyle.Critical, "ERROR!")
        End If

    End Sub

    Private Sub mnuCOMS_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles mnuCOMS.SelectedIndexChanged
        SaveSetting("USB Relaycard Tray", "Configuration", "COM", mnuCOMS.SelectedItem)
        mnuR1.Checked = False
        mnuR2.Checked = False
        mnuR3.Checked = False
        mnuR4.Checked = False
    End Sub
End Module